# NOTE: upstream does not have a version numbering scheme (there has only been
# one release so far), so I have chosen to use the date of release as the
# version number.

Name:           lfsc
Version:        0.20120321
Release:        4%{?dist}
Summary:        SMT proof checker

License:        BSD
URL:            http://clc.cs.uiowa.edu/lfsc/
Source0:        http://clc.cs.uiowa.edu/%{name}/%{name}_src.zip
Source1:        http://clc.cs.uiowa.edu/%{name}/license.txt
# Man page written by Jerry James from text available on the lfsc web site;
# i.e., I wrote the formatting only, not the text, so this file is covered
# under the same copyright and license as the source code.
Source2:        %{name}.1
# Source text for the man page.  Use this to validate the man page on update.
Source3:        http://clc.cs.uiowa.edu/lfsc/readme-lfsc.txt
# Proof file used to check the validity of a build.
Source4:        check.plf
# The next few sources contain commonly used proof definitions
Source5:        http://clc.cs.uiowa.edu/lfsc/sat.plf
Source6:        http://clc.cs.uiowa.edu/lfsc/smt.plf
Source7:        http://clc.cs.uiowa.edu/lfsc/th_base.plf
Source8:        http://clc.cs.uiowa.edu/lfsc/th_real.plf
Source9:        http://clc.cs.uiowa.edu/lfsc/th_lra.plf
Source10:       http://clc.cs.uiowa.edu/lfsc/th_lra-cvc3.plf
Source11:       http://clc.cs.uiowa.edu/lfsc/color_base.plf
Source12:       http://clc.cs.uiowa.edu/lfsc/color_euf.plf
Source13:       http://clc.cs.uiowa.edu/lfsc/euf_interpolation.plf
# Sent upstream 4 Dec 2012.  Fix a build failure due to a missing prototype
# for _exit().
Patch0:         %{name}-exit.patch

BuildRequires:  gmp-devel

%description
This package contains an SMT proof checker.

%package devel
Summary:        Files needed to compile side conditions
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:       gmp-devel%{?_isa}

%description devel
This package contains the files needed to compile a version of %{name} that
can execute a side condition.

%prep
%setup -q -c
%patch0
cp -p %{SOURCE1} .

# Use the correct compiler flags
sed -ri 's/-(O4|w)//' Makefile

%build
make %{?_smp_mflags} CP_OPTS="%{optflags} -fsigned-char -D_FILE_OFFSET_BITS=64"

%install
# Install the main binary
mkdir -p %{buildroot}%{_bindir}
install -m 0755 -p opt/%{name} %{buildroot}%{_bindir}

# Install the man page
mkdir -p %{buildroot}%{_mandir}/man1
cp -p %{SOURCE2} %{buildroot}%{_mandir}/man1

# Install the development source files
mkdir -p %{buildroot}%{_libdir}/%{name}/opt
install -m 0644 -p check.h chunking_memory_management.h code.cpp code.h \
  expr.h trie.h Makefile %{buildroot}%{_libdir}/%{name}

# Install the development binary files
install -m 0644 -p opt/Makefile.d opt/*.o %{buildroot}%{_libdir}/%{name}/opt
cp -a opt/deps %{buildroot}%{_libdir}/%{name}/opt

# Install the proof files
mkdir -p %{buildroot}%{_datadir}/%{name}
cp -p %{SOURCE5} %{SOURCE6} %{SOURCE7} %{SOURCE8} %{SOURCE9} %{SOURCE10} \
   %{SOURCE11} %{SOURCE12} %{SOURCE13} %{buildroot}%{_datadir}/%{name}

%check
opt/%{name} %{SOURCE5} %{SOURCE4}

%files
%doc license.txt
%{_bindir}/%{name}
%{_datadir}/%{name}/
%{_mandir}/man1/%{name}.1*

%files devel
%{_libdir}/%{name}/

%changelog
* Mon May  6 2013 Jerry James <loganjerry@gmail.com> - 0.20120321-4
- Package proof files for use by CVC4, etc.

* Thu Apr 25 2013 Jerry James <loganjerry@gmail.com> - 0.20120321-3
- Build with -fsigned-char to prevent infloop when char is unsigned

* Tue Apr 16 2013 Jerry James <loganjerry@gmail.com> - 0.20120321-2
- Add source3 as a reminder to update source2
- Add a check script, and source4 and source5 to feed it

* Wed Jan 23 2013 Jerry James <loganjerry@gmail.com> - 0.20120321-1
- Initial RPM
